<?php 

namespace App\Controller\enrollements;

use App\Controller\Osms\Osms;
use App\Entity\Application;
use App\Entity\BaseRedevable;
use App\Entity\Echeance;
use App\Entity\Enrollement;
use App\Entity\Pays;
use Doctrine\ORM\EntityManagerInterface;

class CreateEnrollement {

    public function __invoke(Enrollement $data, EntityManagerInterface $em) {
        $taxe = null;

        $data->setEnabled(false);
        $data->setCreatedAt(new \DateTime());
        $data->setUpdatedAt(new \DateTime());

        $em->persist($data);
        $em->flush();
        ($data->getActivite())?$taxes = $data->getActivite()->getBaseRedevables():null;
        if($taxes != null){
            /** @var BaseRedevable $tax */
            foreach ($taxes as $tax){
                /** @var Application $application */
                foreach($tax->getApplications() as $application){
                    if($application->getAnnee() == date('Y')){
                        if($application->getRamification() === $data->getUsager()->getRamification()){
                            switch ($tax->getFrequence()->getNom()){
                                case "Mensuelle":
                                    //dump($tax->getFrequence()); exit;
                                    for($i=1; $i<=12; $i++){
                                        $echeance = new Echeance();

                                        $echeance->setMontant($application->getTarif());
                                        $echeance->setIsPaid(false);
                                        $echeance->setUsager($data->getUsager());

                                        $echeance->setCreatedAt(new \datetime);
                                        $echeance->setUpdatedAt(new \datetime);
                                        $echeance->setEnrollement($data);
                                        $echeance->setAnnee(date('Y'));

                                        $echeance->setMois($i);
                                        $echeance->setEnrollement($data);
                                        $echeance->setRedevance($tax);

                                        $em->persist($echeance);
                                        $em->flush();
                                    }

                                    break;
                                case "Annuelle":
                                    // dump($tax->getFrequence()); exit;

                                    $echeance = new Echeance();

                                    $echeance->setMontant(trim($application->getTarif()));
                                    $echeance->setIsPaid(false);
                                    $echeance->setEnrollement($data);

                                    $echeance->setCreatedAt(new \datetime);
                                    $echeance->setUpdatedAt(new \datetime);
                                    $echeance->setAnnee(date("Y"));
                                    $echeance->setUsager($data->getUsager());
                                    $echeance->setRedevance($tax);

                                    $em->persist($echeance);
                                    $em->flush();
                                    break;


                            }
                        }

                    }

                }

            }

        }
        $this->sendSMS($data->getUsager()->getTelephone(), "Bonjour ". $data->getUsager()->getFullName() . ", \n Votre identification au Bureau Malien des droits d'auteur est bien éffectif ! Votre numero BUMDA est: ". $data->getUsager()->getNumBumda() . " \nInfoline: 99 61 61 61 / 91 22 22 24" );

        return $data;
    }

    public function sendSMS($phone, $message)
    {
        $config = array(
            'clientId' => '2qSWqSPGFxCKSP8BPaGTI8X4k8rwZK8e',
            'clientSecret' =>  '7rBmxm7sJq90obiJ',
        );

        $osms = new Osms($config);

        $data = $osms->getTokenFromConsumerKey();
        $token = array(
            'token' => $data['access_token']
        );

        $response = $osms->sendSms(
        // sender
            'tel:+223760000000',
            // receiver
            'tel:+223' . $phone,
            // message
            $message,
            'KLISPAY'
        );
        // dump($response); exit;
    }

}