<?php

namespace App\Controller\transactions;

use App\Entity\Paiement;
use App\Entity\Transaction;
use Doctrine\ORM\EntityManagerInterface;
use Foris\OmSdk\OmSdk;
use Symfony\Component\HttpFoundation\Request;

class CheckTransaction
{
    protected $em;
    protected $request;

    public function __construct(EntityManagerInterface $em)
    {
        $this->em = $em;
    }

    public function __invoke(Request $request)
    {
        /** @var Transaction $transaction */

        $transaction = $this->em->getRepository(Transaction::class)->find($request->get('id'));

       // dd($transaction->getEcheance());

        $om = new OmSdk();
        $config = [];

        //$rep= $om->getAccesToken();
        $trans = $om->checkTransactionStatus($transaction->getOrderId(), $transaction->getMontant(), $transaction->getPayToken());
        // dump($rep); exit;
        /** @var Paiement $paiement */
        foreach ($transaction->getPaiements() as $paiement){
            $totalPayer = 0;
           if ($paiement->isIsPaid() === false){
               /** @var Transaction $tran */
               foreach ($paiement->getTransactions() as $tran){
                   if ($tran->getStatut() === 'Confirmé'){
                       $totalPayer = $totalPayer+$paiement->getMontant();

                       if ($totalPayer >= $paiement->getEcheance()->getMontant()){
                           $paiement->setIsPaid(true);
                           $this->em->flush();
                       }
                   }
               }
           }

        }



        if(!empty($trans)){
            if($trans['status'] == "SUCCESS"){
                $transaction->setStatut("Confirmé");
                $this->em->flush();
            }else{

                $transaction->setStatut($trans['status']);
                $this->em->flush();
            }
        }

        $result = ["unique" => [
            "id" => $transaction->getId(),
            "nomContribuable" => $transaction->getUsager()->getFullName(),
            "montant" => $transaction->getMontant(),
            "statut" => $transaction->getStatut(),
            "paymentUrl" => $transaction->getPaymentUrl()
        ]

        ];

        return $result;
    }
}