<?php

namespace App\Controller\transactions;

use App\Entity\Paiement;
use App\Entity\Transaction;
use Doctrine\ORM\EntityManagerInterface;
use Foris\OmSdk\OmSdk;

class CreateTransaction
{
    public function __invoke(Transaction $data, EntityManagerInterface $em)
    {
        $data->setCreatedAt(new \datetime);
        $em->persist($data);
        $em->flush();
        //$co = $data->getEcheance()->getId();
      //  dd($data->getPaiements());

        $data->setPaiements($data->getPaiements());

        $order_id = "KLISPAY_".date("dmYHis");
        $data->setOrderId($order_id);
        if($data->getMoyenPaiement()->getNom() == 'Orange Money'){
            $om = new OmSdk();
            $config = [];

            //  $rep= $om->getAccesToken();
            $opt=[
                "merchant_key"=> 'ebb9fd01',
                "currency"=> "XOF",
                "order_id"=> $order_id,
                "amount"=> $data->getMontant(),
                "return_url"=> 'http://assanti.ml:8003/callback/return',
                "cancel_url"=> 'http://assanti.ml:8003/callback/cancel',
                "notif_url"=>'http://assanti.ml/notif_callback.php',
                "lang"=> "fr"
            ];
            $pay = $om->webPayment($opt);
            // dump($pay); exit;

            $data->setStatut('En attente de confirmation');
            $data->setOrderId($order_id);
            $data->setPayToken($pay['pay_token']);
            $data->setPaymentUrl($pay['payment_url']);
            $data->setNotifToken($pay['notif_token']);
            $em->flush();
        }
        else{
           /* $echeance = $data->getEcheance();
            $totalPayer = 0;

            foreach ($echeance->getTransactions() as $tran){
                if ($tran->getStatut() === 'Confirmé')
                    $totalPayer = $totalPayer+$tran->getMontant();
            }
            if ($totalPayer+$data->getMontant()  >= $echeance->getMontant()){
                $echeance->setIsPaid(true);
                $em->flush();
            }*/
            $data->setStatut("Confirmé");
            $data->setOrderId($order_id);
            $totalPayer = 0;
            /** @var Paiement $paiement */
            foreach ($data->getPaiements() as $paiement){
                foreach ($paiement->getTransactions() as $transaction){
                    if ($transaction->getStatut() === 'Confirmé'){
                        $totalPayer = $totalPayer+$transaction->getMontant();

                        if ($totalPayer >= $paiement->getMontant()){
                            $paiement->setIsPaid(true);
                            $em->flush();
                        }
                    }

                }

            }

            $em->flush();
        }

        return $data;
    }

}