<?php

namespace App\Controller\transactions;

use App\Constants;
use App\Controller\BaseController;
use App\Repository\ContribuableRepository;
use App\Repository\TransactionRepository;

class ListeTransactions extends BaseController
{

    public function __invoke( \Symfony\Component\HttpFoundation\Request $request, TransactionRepository $repository)
    {
        // Appel de la méthode commune pour obtenir les résultats
        $response = $this->getList($repository,$request, 'trans.createdAt', array_merge(Constants::CONTRIBUABLE, Constants::RAMIFICATION, Constants::ENTITE, Constants::USER, Constants::TRANSACTION, Constants::MOYEN_PAIEMENT, Constants::ECHEANCE, Constants::CARTES, Constants::TAXES, Constants::CATEGORIE_TAXES));

        $data = $response->getData();
        $meta = $response->getMeta();

        return [
            'data'=> $data,
            'meta' => $meta
        ];
    }
}