<?php

// src/Repository/BaseRepository.php

namespace App\Repository;

use Artprima\QueryFilterBundle\Query\ConditionManager;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

class BaseRepository extends ServiceEntityRepository
{
    /** @var ConditionManager  */
    protected ConditionManager $pqbManager;

    public function __construct(ManagerRegistry $registry, ConditionManager $manager)
    {
        parent::__construct($registry, $this->getEntityClass());
        $this->pqbManager = $manager;
    }

    public function save($entity, bool $flush = false)
    {
        $this->getEntityManager()->persist($entity);

        if ($flush) {
            $this->getEntityManager()->flush();
        }
    }

    public function remove($entity, bool $flush = false)
    {
        $this->getEntityManager()->remove($entity);

        if ($flush) {
            $this->getEntityManager()->flush();
        }
    }



    // Cette méthode doit être implémentée dans chaque repository spécifique à une entité
    protected function getEntityClass(): string
    {
        return ''; // Renvoyer le nom complet de la classe de l'entité spécifique
    }
}
