<?php

namespace App\Repository;

use App\Entity\Precision;
use Artprima\QueryFilterBundle\Query\ConditionManager;
use Artprima\QueryFilterBundle\QueryFilter\QueryFilterArgs;
use Artprima\QueryFilterBundle\QueryFilter\QueryResult;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\ORM\Tools\Pagination\Paginator;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @extends ServiceEntityRepository<Precision>
 *
 * @method Precision|null find($id, $lockMode = null, $lockVersion = null)
 * @method Precision|null findOneBy(array $criteria, array $orderBy = null)
 * @method Precision[]    findAll()
 * @method Precision[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class PrecisionRepository extends ServiceEntityRepository
{
         /**
     * @var ConditionManager
     */
    private $pqbManager;
    public function __construct(ManagerRegistry $registry, ConditionManager $manager)
    {
        parent::__construct($registry, Precision::class);
        $this->pqbManager = $manager;
    }
    public function findByOrderBy(QueryFilterArgs $args): QueryResult
    {
        // Build our request
        $qb = $this->createQueryBuilder('pr')
            ->setFirstResult($args->getOffset())
            ->setMaxResults($args->getLimit());

        $proxyQb = $this->pqbManager->wrapQueryBuilder($qb);
        $qb = $proxyQb->getSortedAndFilteredQueryBuilder($args->getSearchBy(), $args->getSortBy());
        $query = $qb->getQuery();
        $paginator = new Paginator($query);

        // return the wrapped result
        return new QueryResult($paginator->getIterator()->getArrayCopy(), count($paginator));
    }    

//    /**
//     * @return Precision[] Returns an array of Precision objects
//     */
//    public function findByExampleField($value): array
//    {
//        return $this->createQueryBuilder('p')
//            ->andWhere('p.exampleField = :val')
//            ->setParameter('val', $value)
//            ->orderBy('p.id', 'ASC')
//            ->setMaxResults(10)
//            ->getQuery()
//            ->getResult()
//        ;
//    }

//    public function findOneBySomeField($value): ?Precision
//    {
//        return $this->createQueryBuilder('p')
//            ->andWhere('p.exampleField = :val')
//            ->setParameter('val', $value)
//            ->getQuery()
//            ->getOneOrNullResult()
//        ;
//    }
}
